Google Cloud Tasks v2 API - Namespace Google.Cloud.Tasks.V2 (3.7.0)

Classes

AppEngineHttpRequest

App Engine HTTP request.

The message defines the HTTP request that is sent to an App Engine app when the task is dispatched.

Using [AppEngineHttpRequest][google.cloud.tasks.v2.AppEngineHttpRequest] requires appengine.applications.get Google IAM permission for the project and the following scope:

https://www.googleapis.com/auth/cloud-platform

The task will be delivered to the App Engine app which belongs to the same project as the queue. For more information, see How Requests are Routed and how routing is affected by dispatch files. Traffic is encrypted during transport and never leaves Google datacenters. Because this traffic is carried over a communication mechanism internal to Google, you cannot explicitly set the protocol (for example, HTTP or HTTPS). The request to the handler, however, will appear to have used the HTTP protocol.

The [AppEngineRouting][google.cloud.tasks.v2.AppEngineRouting] used to construct the URL that the task is delivered to can be set at the queue-level or task-level:

  • If [app_engine_routing_override is set on the queue][google.cloud.tasks.v2.Queue.app_engine_routing_override], this value is used for all tasks in the queue, no matter what the setting is for the [task-level app_engine_routing][google.cloud.tasks.v2.AppEngineHttpRequest.app_engine_routing].

The url that the task will be sent to is:

  • url = [host][google.cloud.tasks.v2.AppEngineRouting.host] + [relative_uri][google.cloud.tasks.v2.AppEngineHttpRequest.relative_uri]

Tasks can be dispatched to secure app handlers, unsecure app handlers, and URIs restricted with login: admin. Because tasks are not run as any user, they cannot be dispatched to URIs restricted with login: required Task dispatches also do not follow redirects.

The task attempt has succeeded if the app's request handler returns an HTTP response code in the range [200 - 299]. The task attempt has failed if the app's handler returns a non-2xx response code or Cloud Tasks does not receive response before the [deadline][google.cloud.tasks.v2.Task.dispatch_deadline]. Failed tasks will be retried according to the [retry configuration][google.cloud.tasks.v2.Queue.retry_config]. 503 (Service Unavailable) is considered an App Engine system error instead of an application error and will cause Cloud Tasks' traffic congestion control to temporarily throttle the queue's dispatches. Unlike other types of task targets, a 429 (Too Many Requests) response from an app handler does not cause traffic congestion control to throttle the queue.

AppEngineRouting

App Engine Routing.

Defines routing characteristics specific to App Engine - service, version, and instance.

For more information about services, versions, and instances see An Overview of App Engine, Microservices Architecture on Google App Engine, App Engine Standard request routing, and App Engine Flex request routing.

Using [AppEngineRouting][google.cloud.tasks.v2.AppEngineRouting] requires appengine.applications.get Google IAM permission for the project and the following scope:

https://www.googleapis.com/auth/cloud-platform

Attempt

The status of a task attempt.

BatchCreateTasksMetadata

Metadata message for [BatchCreateTasks].

BatchCreateTasksMetadata.Types

Container for nested types declared in the BatchCreateTasksMetadata message type.

BatchCreateTasksRequest

Request message for [BatchCreateTasks].

BatchCreateTasksResponse

Response message for [BatchCreateTasks].

BatchDeleteTasksMetadata

Metadata for the long-running operation returned by [BatchDeleteTasks][google.cloud.tasks.v2.CloudTasks.BatchDeleteTasks]. This message is used to hold metadata information about the batch delete tasks operation; that is, it is put in [google.longrunning.Operation.metadata][google.longrunning.Operation.metadata].

BatchDeleteTasksMetadata.Types

Container for nested types declared in the BatchDeleteTasksMetadata message type.

BatchDeleteTasksRequest

Request message for deleting a batch of tasks using [BatchDeleteTasks][google.cloud.tasks.v2.CloudTasks.BatchDeleteTasks].

CloudTasks

Cloud Tasks allows developers to manage the execution of background work in their applications.

CloudTasks.CloudTasksBase

Base class for server-side implementations of CloudTasks

CloudTasks.CloudTasksClient

Client for CloudTasks

CloudTasksClient

CloudTasks client wrapper, for convenient use.

CloudTasksClientBuilder

Builder class for CloudTasksClient to provide simple configuration of credentials, endpoint etc.

CloudTasksClientImpl

CloudTasks client wrapper implementation, for convenient use.

CloudTasksSettings

Settings for CloudTasksClient instances.

CmekConfig

Describes the customer-managed encryption key (CMEK) configuration associated with a project and location.

CmekConfigName

Resource name for the CmekConfig resource.

CreateQueueRequest

Request message for [CreateQueue][google.cloud.tasks.v2.CloudTasks.CreateQueue].

CreateTaskRequest

Request message for [CreateTask][google.cloud.tasks.v2.CloudTasks.CreateTask].

CryptoKeyName

Resource name for the CryptoKey resource.

DeleteQueueRequest

Request message for [DeleteQueue][google.cloud.tasks.v2.CloudTasks.DeleteQueue].

DeleteTaskRequest

Request message for deleting a task using [DeleteTask][google.cloud.tasks.v2.CloudTasks.DeleteTask].

GetCmekConfigRequest

Request message for [GetCmekConfig][google.cloud.tasks.v2.CloudTasks.GetCmekConfig].

GetQueueRequest

Request message for [GetQueue][google.cloud.tasks.v2.CloudTasks.GetQueue].

GetTaskRequest

Request message for getting a task using [GetTask][google.cloud.tasks.v2.CloudTasks.GetTask].

HttpRequest

HTTP request.

The task will be pushed to the worker as an HTTP request. If the worker or the redirected worker acknowledges the task by returning a successful HTTP response code ([200 - 299]), the task will be removed from the queue. If any other HTTP response code is returned or no response is received, the task will be retried according to the following:

  • User-specified throttling: [retry configuration][google.cloud.tasks.v2.Queue.retry_config], [rate limits][google.cloud.tasks.v2.Queue.rate_limits], and the [queue's state][google.cloud.tasks.v2.Queue.state].

  • System throttling: To prevent the worker from overloading, Cloud Tasks may temporarily reduce the queue's effective rate. User-specified settings will not be changed.

    System throttling happens because:

    • Cloud Tasks backs off on all errors. Normally the backoff specified in [rate limits][google.cloud.tasks.v2.Queue.rate_limits] will be used. But if the worker returns 429 (Too Many Requests), 503 (Service Unavailable), or the rate of errors is high, Cloud Tasks will use a higher backoff rate. The retry specified in the Retry-After HTTP response header is considered.

    • To prevent traffic spikes and to smooth sudden increases in traffic, dispatches ramp up slowly when the queue is newly created or idle and if large numbers of tasks suddenly become available to dispatch (due to spikes in create task rates, the queue being unpaused, or many tasks that are scheduled at the same time).

HttpTarget

HTTP target.

When specified at the [Queue][google.cloud.tasks.v2.Queue] level, all tasks with [HttpRequest][google.cloud.tasks.v2.HttpRequest] are overridden according to the target.

HttpTarget.Types

Container for nested types declared in the HttpTarget message type.

HttpTarget.Types.Header

Defines a header message. A header can have a key and a value.

HttpTarget.Types.HeaderOverride

Wraps the Header object.

ListQueuesRequest

Request message for [ListQueues][google.cloud.tasks.v2.CloudTasks.ListQueues].

ListQueuesResponse

Response message for [ListQueues][google.cloud.tasks.v2.CloudTasks.ListQueues].

ListTasksRequest

Request message for listing tasks using [ListTasks][google.cloud.tasks.v2.CloudTasks.ListTasks].

ListTasksResponse

Response message for listing tasks using [ListTasks][google.cloud.tasks.v2.CloudTasks.ListTasks].

OAuthToken

Contains information needed for generating an OAuth token. This type of authorization should generally only be used when calling Google APIs hosted on *.googleapis.com.

OidcToken

Contains information needed for generating an OpenID Connect token. This type of authorization can be used for many scenarios, including calling Cloud Run, or endpoints where you intend to validate the token yourself.

PathOverride

PathOverride.

Path message defines path override for HTTP targets.

PauseQueueRequest

Request message for [PauseQueue][google.cloud.tasks.v2.CloudTasks.PauseQueue].

PurgeQueueRequest

Request message for [PurgeQueue][google.cloud.tasks.v2.CloudTasks.PurgeQueue].

QueryOverride

QueryOverride.

Query message defines query override for HTTP targets.

Queue

A queue is a container of related tasks. Queues are configured to manage how those tasks are dispatched. Configurable properties include rate limits, retry options, queue types, and others.

Queue.Types

Container for nested types declared in the Queue message type.

QueueName

Resource name for the Queue resource.

RateLimits

Rate limits.

This message determines the maximum rate that tasks can be dispatched by a queue, regardless of whether the dispatch is a first task attempt or a retry.

Note: The debugging command, [RunTask][google.cloud.tasks.v2.CloudTasks.RunTask], will run a task even if the queue has reached its [RateLimits][google.cloud.tasks.v2.RateLimits].

ResumeQueueRequest

Request message for [ResumeQueue][google.cloud.tasks.v2.CloudTasks.ResumeQueue].

RetryConfig

Retry config.

These settings determine when a failed task attempt is retried.

RunTaskRequest

Request message for forcing a task to run now using [RunTask][google.cloud.tasks.v2.CloudTasks.RunTask].

StackdriverLoggingConfig

Configuration options for writing logs to Stackdriver Logging.

Task

A unit of scheduled work.

Task.Types

Container for nested types declared in the Task message type.

TaskName

Resource name for the Task resource.

UpdateCmekConfigRequest

Request message for [UpdateCmekConfig][google.cloud.tasks.v2.CloudTasks.UpdateCmekConfig].

UpdateQueueRequest

Request message for [UpdateQueue][google.cloud.tasks.v2.CloudTasks.UpdateQueue].

UriOverride

URI Override.

When specified, all the HTTP tasks inside the queue will be partially or fully overridden depending on the configured values.

UriOverride.Types

Container for nested types declared in the UriOverride message type.

Enums

BatchCreateTasksMetadata.Types.State

The state of the batch create operation.

BatchDeleteTasksMetadata.Types.State

The state of the batch delete operation. This enum is not frozen and new values may be added in the future.

CmekConfigName.ResourceNameType

The possible contents of CmekConfigName.

CryptoKeyName.ResourceNameType

The possible contents of CryptoKeyName.

HttpMethod

The HTTP method used to deliver the task.

HttpRequest.AuthorizationHeaderOneofCase

Enum of possible cases for the "authorization_header" oneof.

HttpTarget.AuthorizationHeaderOneofCase

Enum of possible cases for the "authorization_header" oneof.

Queue.Types.State

State of the queue.

QueueName.ResourceNameType

The possible contents of QueueName.

Task.MessageTypeOneofCase

Enum of possible cases for the "message_type" oneof.

Task.Types.View

The view specifies a subset of [Task][google.cloud.tasks.v2.Task] data.

When a task is returned in a response, not all information is retrieved by default because some data, such as payloads, might be desirable to return only when needed because of its large size or because of the sensitivity of data that it contains.

TaskName.ResourceNameType

The possible contents of TaskName.

UriOverride.Types.Scheme

The Scheme for an HTTP request. By default, it is HTTPS.

UriOverride.Types.UriOverrideEnforceMode

UriOverrideEnforceMode defines when the URI override is enforced.